diff --git src/wp-admin/css/common.css src/wp-admin/css/common.css
index 6fe50ac93c..9df2a9827b 100644
--- src/wp-admin/css/common.css
+++ src/wp-admin/css/common.css
@@ -3027,6 +3027,12 @@ img {
 	height: calc( 100vh - 220px );
 }
 
+#template label {
+	display: inline-block;
+	margin-bottom: 1em;
+	font-weight: 600;
+}
+
 /* rtl:ignore */
 #template textarea,
 #docs-list {
diff --git src/wp-admin/css/customize-controls.css src/wp-admin/css/customize-controls.css
index fd272d849e..bcf308f03e 100644
--- src/wp-admin/css/customize-controls.css
+++ src/wp-admin/css/customize-controls.css
@@ -550,12 +550,7 @@ p.customize-section-description {
 	margin-top: 22px;
 	margin-bottom: 0;
 }
-.customize-section-description ul {
-	margin-left: 1em;
-}
-.customize-section-description ul > li {
-	list-style: disc;
-}
+
 .section-description-buttons {
 	text-align: right;
 }
@@ -1155,12 +1150,17 @@ p.customize-section-description {
 	tab-size: 4;
 }
 
+.customize-section-description-container + #customize-control-custom_css .customize-control-title {
+	margin-left: 12px;
+}
+
 .customize-section-description-container + #customize-control-custom_css:last-child textarea {
 	border-right: 0;
 	border-left: 0;
 	height: calc( 100vh - 185px );
 	resize: none;
 }
+
 .customize-section-description-container + #customize-control-custom_css:last-child {
 	margin-left: -12px;
 	width: 299px;
@@ -1171,6 +1171,7 @@ p.customize-section-description {
 .customize-section-description-container + #customize-control-custom_css:last-child .CodeMirror {
 	height: calc( 100vh - 185px );
 }
+
 .CodeMirror-lint-tooltip,
 .CodeMirror-hints {
 	z-index: 500000 !important;
@@ -1185,6 +1186,7 @@ p.customize-section-description {
 	.customize-section-description-container + #customize-control-custom_css:last-child {
 		margin-right: 0;
 	}
+
 	.customize-section-description-container + #customize-control-custom_css:last-child textarea {
 		height: calc( 100vh - 140px );
 	}
diff --git src/wp-admin/js/customize-controls.js src/wp-admin/js/customize-controls.js
index f72110fce1..425eef4268 100644
--- src/wp-admin/js/customize-controls.js
+++ src/wp-admin/js/customize-controls.js
@@ -1159,7 +1159,7 @@
 				content = meta.find( '.customize-section-description:first' );
 				content.toggleClass( 'open' );
 				content.slideToggle();
-				content.attr( 'aria-expanded', function ( i, attr ) {
+				$( this ).attr( 'aria-expanded', function ( i, attr ) {
 					return 'true' === attr ? 'false' : 'true';
 				});
 			});
@@ -1871,12 +1871,7 @@
 
 			meta = panel.container.find( '.panel-meta:first' );
 
-			meta.find( '> .accordion-section-title .customize-help-toggle' ).on( 'click keydown', function( event ) {
-				if ( api.utils.isKeydownButNotEnterEvent( event ) ) {
-					return;
-				}
-				event.preventDefault(); // Keep this AFTER the key filter above
-
+			meta.find( '> .accordion-section-title .customize-help-toggle' ).on( 'click', function( event ) {
 				if ( meta.hasClass( 'cannot-expand' ) ) {
 					return;
 				}
@@ -5656,23 +5651,25 @@
 
 			ready = $.when( sectionReady, controlReady );
 
-			// Set up the section desription behaviors.
+			// Set up the section description behaviors.
 			ready.done( function setupSectionDescription( section, control ) {
 
 				// Close the section description when clicking the close button.
 				section.container.find( '.section-description-buttons .section-description-close' ).on( 'click', function() {
 					section.container.find( '.section-meta .customize-section-description:first' )
 						.removeClass( 'open' )
-						.slideUp()
-						.attr( 'aria-expanded', 'false' );
+						.slideUp();
+					section.container.find( '.customize-help-toggle' )
+						.attr( 'aria-expanded', 'false' )
+						.focus(); // Avoid focus loss.
 				});
 
 				// Reveal help text if setting is empty.
 				if ( ! control.setting.get() ) {
 					section.container.find( '.section-meta .customize-section-description:first' )
 						.addClass( 'open' )
-						.show()
-						.attr( 'aria-expanded', 'true' );
+						.show();
+					section.container.find( '.customize-help-toggle' ).attr( 'aria-expanded', 'true' );
 				}
 			});
 
@@ -5760,6 +5757,15 @@
 
 					control.editor = wp.codeEditor.initialize( $textarea, settings );
 
+					// Improve the editor accessibility.
+					$( control.editor.codemirror.display.lineDiv )
+						.attr({
+							role: 'textbox',
+							'aria-multiline': 'true',
+							'aria-label': control.params.label,
+							'aria-describedby': 'editor-keyboard-trap-help'
+						});
+
 					// Refresh when receiving focus.
 					control.editor.codemirror.on( 'focus', function( codemirror ) {
 						codemirror.refresh();
diff --git src/wp-admin/js/theme-plugin-editor.js src/wp-admin/js/theme-plugin-editor.js
index f43363b0c7..55ed2b5374 100644
--- src/wp-admin/js/theme-plugin-editor.js
+++ src/wp-admin/js/theme-plugin-editor.js
@@ -83,6 +83,15 @@ wp.themePluginEditor = (function( $ ) {
 
 		editor = wp.codeEditor.initialize( $( '#newcontent' ), codeEditorSettings );
 
+		// Improve the editor accessibility.
+		$( editor.codemirror.display.lineDiv )
+			.attr({
+				role: 'textbox',
+				'aria-multiline': 'true',
+				'aria-labelledby': 'theme-plugin-editor-label',
+				'aria-describedby': 'editor-keyboard-trap-help'
+			});
+
 		component.instance = editor;
 	};
 
diff --git src/wp-admin/js/widgets/custom-html-widgets.js src/wp-admin/js/widgets/custom-html-widgets.js
index 5f49b79279..a6d3074d39 100644
--- src/wp-admin/js/widgets/custom-html-widgets.js
+++ src/wp-admin/js/widgets/custom-html-widgets.js
@@ -210,6 +210,16 @@ wp.customHtmlWidgets = ( function( $ ) {
 			});
 
 			control.editor = wp.codeEditor.initialize( control.fields.content, settings );
+
+			// Improve the editor accessibility.
+			$( control.editor.codemirror.display.lineDiv )
+				.attr({
+					role: 'textbox',
+					'aria-multiline': 'true',
+					'aria-labelledby': control.fields.content[0].id + '-label',
+					'aria-describedby': 'editor-keyboard-trap-help'
+				});
+
 			control.fields.content.on( 'change', function() {
 				if ( this.value !== control.editor.codemirror.getValue() ) {
 					control.editor.codemirror.setValue( this.value );
diff --git src/wp-admin/plugin-editor.php src/wp-admin/plugin-editor.php
index 9816a5d48c..4c593be0dc 100644
--- src/wp-admin/plugin-editor.php
+++ src/wp-admin/plugin-editor.php
@@ -178,7 +178,7 @@ if ( isset( $_REQUEST['action'] ) && 'update' === $_REQUEST['action'] ) {
 		'<p>' . __('You can use the editor to make changes to any of your plugins&#8217; individual PHP files. Be aware that if you make changes, plugins updates will overwrite your customizations.') . '</p>' .
 		'<p>' . __('Choose a plugin to edit from the dropdown menu and click the Select button. Click once on any file name to load it in the editor, and make your changes. Don&#8217;t forget to save your changes (Update File) when you&#8217;re finished.') . '</p>' .
 		'<p>' . __('The Documentation menu below the editor lists the PHP functions recognized in the plugin file. Clicking Look Up takes you to a web page about that particular function.') . '</p>' .
-		'<p id="newcontent-description">' . __( 'In the editing area the Tab key enters a tab character. To move below this area by pressing Tab, press the Esc key followed by the Tab key. In some cases the Esc key will need to be pressed twice before the Tab key will allow you to continue.' ) . '</p>' .
+		'<p id="editor-keyboard-trap-help">' . __( 'When using a keyboard: In the editing area the Tab key enters a tab character. To move away from this area by pressing Tab, press the Esc key followed by the Tab key. Screen reader users: you may need to press the Esc key twice to exit forms mode and then to allow the Tab key to move away from the editing area.' ) . '</p>' .
 		'<p>' . __('If you want to make changes but don&#8217;t want them to be overwritten when the plugin is updated, you may be ready to think about writing your own plugin. For information on how to edit plugins, write your own from scratch, or just better understand their anatomy, check out the links below.') . '</p>' .
 		( is_network_admin() ? '<p>' . __('Any edits to files from this screen will be reflected on all sites in the network.') . '</p>' : '' )
 	) );
@@ -238,7 +238,7 @@ if ( isset( $_REQUEST['action'] ) && 'update' === $_REQUEST['action'] ) {
 
 <div class="fileedit-sub">
 <div class="alignleft">
-<big><?php
+<h2><?php
 	if ( is_plugin_active( $plugin ) ) {
 		if ( is_writeable( $real_file ) ) {
 			/* translators: %s: plugin file name */
@@ -256,7 +256,7 @@ if ( isset( $_REQUEST['action'] ) && 'update' === $_REQUEST['action'] ) {
 			echo sprintf( __( 'Browsing %s (inactive)' ), '<strong>' . $file . '</strong>' );
 		}
 	}
-	?></big>
+	?></h2>
 </div>
 <div class="alignright">
 	<form action="plugin-editor.php" method="post">
@@ -304,11 +304,13 @@ foreach ( $plugin_files as $plugin_file ) :
 </div>
 <form name="template" id="template" action="plugin-editor.php" method="post">
 	<?php wp_nonce_field('edit-plugin_' . $file) ?>
-		<div><textarea cols="70" rows="25" name="newcontent" id="newcontent" aria-describedby="newcontent-description"><?php echo $content; ?></textarea>
-		<input type="hidden" name="action" value="update" />
-		<input type="hidden" name="file" value="<?php echo esc_attr($file) ?>" />
-		<input type="hidden" name="plugin" value="<?php echo esc_attr($plugin) ?>" />
-		<input type="hidden" name="scrollto" id="scrollto" value="<?php echo $scrollto; ?>" />
+		<div>
+			<label for="newcontent" id="theme-plugin-editor-label"><?php _e( 'Selected file content:' ); ?></label>
+			<textarea cols="70" rows="25" name="newcontent" id="newcontent" aria-describedby="editor-keyboard-trap-help"><?php echo $content; ?></textarea>
+			<input type="hidden" name="action" value="update" />
+			<input type="hidden" name="file" value="<?php echo esc_attr($file) ?>" />
+			<input type="hidden" name="plugin" value="<?php echo esc_attr($plugin) ?>" />
+			<input type="hidden" name="scrollto" id="scrollto" value="<?php echo $scrollto; ?>" />
 		</div>
 		<?php if ( !empty( $docs_select ) ) : ?>
 		<div id="documentation" class="hide-if-no-js"><label for="docs-list"><?php _e('Documentation:') ?></label> <?php echo $docs_select ?> <input type="button" class="button" value="<?php esc_attr_e( 'Look Up' ) ?> " onclick="if ( '' != jQuery('#docs-list').val() ) { window.open( 'https://api.wordpress.org/core/handbook/1.0/?function=' + escape( jQuery( '#docs-list' ).val() ) + '&amp;locale=<?php echo urlencode( get_user_locale() ) ?>&amp;version=<?php echo urlencode( get_bloginfo( 'version' ) ) ?>&amp;redirect=true'); }" /></div>
diff --git src/wp-admin/theme-editor.php src/wp-admin/theme-editor.php
index 2fb8d20de5..1d910d19d5 100644
--- src/wp-admin/theme-editor.php
+++ src/wp-admin/theme-editor.php
@@ -27,7 +27,7 @@ get_current_screen()->add_help_tab( array(
 	'<p>' . __('You can use the Theme Editor to edit the individual CSS and PHP files which make up your theme.') . '</p>
 	<p>' . __( 'Begin by choosing a theme to edit from the dropdown menu and clicking the Select button. A list then appears of the theme&#8217;s template files. Clicking once on any file name causes the file to appear in the large Editor box.' ) . '</p>
 	<p>' . __('For PHP files, you can use the Documentation dropdown to select from functions recognized in that file. Look Up takes you to a web page with reference material about that particular function.') . '</p>
-	<p id="newcontent-description">' . __( 'In the editing area the Tab key enters a tab character. To move below this area by pressing Tab, press the Esc key followed by the Tab key. In some cases the Esc key will need to be pressed twice before the Tab key will allow you to continue.' ) . '</p>
+	<p id="editor-keyboard-trap-help">' . __( 'When using a keyboard: In the editing area the Tab key enters a tab character. To move away from this area by pressing Tab, press the Esc key followed by the Tab key. Screen reader users: you may need to press the Esc key twice to exit forms mode and then to allow the Tab key to move away from the editing area.' ) . '</p>
 	<p>' . __('After typing in your edits, click Update File.') . '</p>
 	<p>' . __('<strong>Advice:</strong> think very carefully about your site crashing if you are live-editing the theme currently in use.') . '</p>
 	<p>' . sprintf( __('Upgrading to a newer version of the same theme will override changes made here. To avoid this, consider creating a <a href="%s">child theme</a> instead.'), __('https://codex.wordpress.org/Child_Themes') ) . '</p>' .
@@ -292,11 +292,13 @@ if ( $allowed_files ) :
 else : ?>
 	<form name="template" id="template" action="theme-editor.php" method="post">
 	<?php wp_nonce_field( 'edit-theme_' . $file . $stylesheet ); ?>
-		<div><textarea cols="70" rows="30" name="newcontent" id="newcontent" aria-describedby="newcontent-description"><?php echo $content; ?></textarea>
-		<input type="hidden" name="action" value="update" />
-		<input type="hidden" name="file" value="<?php echo esc_attr( $relative_file ); ?>" />
-		<input type="hidden" name="theme" value="<?php echo esc_attr( $theme->get_stylesheet() ); ?>" />
-		<input type="hidden" name="scrollto" id="scrollto" value="<?php echo $scrollto; ?>" />
+		<div>
+			<label for="newcontent" id="theme-plugin-editor-label"><?php _e( 'Selected file content:' ); ?></label>
+			<textarea cols="70" rows="30" name="newcontent" id="newcontent" aria-describedby="editor-keyboard-trap-help"><?php echo $content; ?></textarea>
+			<input type="hidden" name="action" value="update" />
+			<input type="hidden" name="file" value="<?php echo esc_attr( $relative_file ); ?>" />
+			<input type="hidden" name="theme" value="<?php echo esc_attr( $theme->get_stylesheet() ); ?>" />
+			<input type="hidden" name="scrollto" id="scrollto" value="<?php echo $scrollto; ?>" />
 		</div>
 	<?php if ( ! empty( $functions ) ) : ?>
 		<div id="documentation" class="hide-if-no-js">
diff --git src/wp-includes/class-wp-customize-manager.php src/wp-includes/class-wp-customize-manager.php
index cead2d0ce9..21987055ef 100644
--- src/wp-includes/class-wp-customize-manager.php
+++ src/wp-includes/class-wp-customize-manager.php
@@ -4202,7 +4202,7 @@ final class WP_Customize_Manager {
 
 		/* Custom CSS */
 		$section_description = '<p>';
-		$section_description .= __( 'Add your own CSS code here to customize the appearance and layout of your site.', 'better-code-editing' );
+		$section_description .= __( 'Add your own CSS code here to customize the appearance and layout of your site.' );
 		$section_description .= sprintf(
 			' <a href="%1$s" class="external-link" target="_blank">%2$s<span class="screen-reader-text">%3$s</span></a>',
 			esc_url( __( 'https://codex.wordpress.org/CSS', 'default' ) ),
@@ -4212,21 +4212,19 @@ final class WP_Customize_Manager {
 		);
 		$section_description .= '</p>';
 
-		$section_description .= '<p>' . __( 'When using a keyboard to navigate:', 'better-code-editing' ) . '</p>';
-		$section_description .= '<ul>';
-		$section_description .= '<li>' . __( 'In the CSS edit field, Tab enters a tab character.', 'better-code-editing' ) . '</li>';
-		$section_description .= '<li>' . __( 'To move keyboard focus, press Esc then Tab for the next element, or Esc then Shift+Tab for the previous element.', 'better-code-editing' ) . '</li>';
-		$section_description .= '</ul>';
+		$section_description .= '<p id="editor-keyboard-trap-help">';
+		$section_description .= __( 'When using a keyboard: In the editing area the Tab key enters a tab character. To move away from this area by pressing Tab, press the Esc key followed by the Tab key. Screen reader users: you may need to press the Esc key twice to exit forms mode and then to allow the Tab key to move away from the editing area.' );
+		$section_description .= '</p>';
 
 		if ( 'false' !== wp_get_current_user()->syntax_highlighting ) {
 			$section_description .= '<p>';
 			$section_description .= sprintf(
 				/* translators: placeholder is link to user profile */
-				__( 'The edit field automatically highlights code syntax. You can disable this in your %s to work in plain text mode.', 'better-code-editing' ),
+				__( 'The edit field automatically highlights code syntax. You can disable this in your %s to work in plain text mode.' ),
 				sprintf(
 					' <a href="%1$s" class="external-link" target="_blank">%2$s<span class="screen-reader-text">%3$s</span></a>',
 					esc_url( get_edit_profile_url() . '#syntax_highlighting' ),
-					__( 'user profile', 'better-code-editing' ),
+					__( 'user profile' ),
 					/* translators: accessibility text */
 					__( '(opens in a new window)', 'default' )
 				)
@@ -4252,11 +4250,13 @@ final class WP_Customize_Manager {
 		$this->add_setting( $custom_css_setting );
 
 		$this->add_control( 'custom_css', array(
+			'label'    => __( 'CSS code' ),
 			'type'     => 'textarea',
 			'section'  => 'custom_css',
 			'settings' => array( 'default' => $custom_css_setting->id ),
 			'input_attrs' => array(
-				'class' => 'code', // Ensures contents displayed as LTR instead of RTL.
+				'class'            => 'code', // Ensures contents displayed as LTR instead of RTL.
+				'aria-describedby' => 'editor-keyboard-trap-help'
 			),
 		) );
 	}
diff --git src/wp-includes/class-wp-customize-panel.php src/wp-includes/class-wp-customize-panel.php
index de839f5ce0..2cfce8ccfe 100644
--- src/wp-includes/class-wp-customize-panel.php
+++ src/wp-includes/class-wp-customize-panel.php
@@ -363,7 +363,7 @@ class WP_Customize_Panel {
 					echo sprintf( __( 'You are customizing %s' ), '<strong class="panel-title">{{ data.title }}</strong>' );
 				?></span>
 				<# if ( data.description ) { #>
-					<button class="customize-help-toggle dashicons dashicons-editor-help" tabindex="0" aria-expanded="false"><span class="screen-reader-text"><?php _e( 'Help' ); ?></span></button>
+					<button type="button" class="customize-help-toggle dashicons dashicons-editor-help" aria-expanded="false"><span class="screen-reader-text"><?php _e( 'Help' ); ?></span></button>
 				<# } #>
 			</div>
 			<# if ( data.description ) { #>
diff --git src/wp-includes/widgets/class-wp-widget-custom-html.php src/wp-includes/widgets/class-wp-widget-custom-html.php
index 7e382960fc..3958565913 100644
--- src/wp-includes/widgets/class-wp-widget-custom-html.php
+++ src/wp-includes/widgets/class-wp-widget-custom-html.php
@@ -213,8 +213,8 @@ class WP_Widget_Custom_HTML extends WP_Widget {
 			</p>
 
 			<p>
-				<label for="{{ elementIdPrefix }}content" class="screen-reader-text"><?php esc_html_e( 'Content:', 'default' ); ?></label>
-				<textarea id="{{ elementIdPrefix }}content" class="widefat code content" rows="16" cols="20"></textarea>
+				<label for="{{ elementIdPrefix }}content" id="{{ elementIdPrefix }}content-label"><?php esc_html_e( 'Content:', 'default' ); ?></label>
+				<textarea id="{{ elementIdPrefix }}content" aria-describedby="editor-keyboard-trap-help" class="widefat code content" rows="16" cols="20"></textarea>
 			</p>
 
 			<?php if ( ! current_user_can( 'unfiltered_html' ) ) : ?>
@@ -250,16 +250,14 @@ class WP_Widget_Custom_HTML extends WP_Widget {
 		$content .= __( 'Use the Custom HTML widget to add arbitrary HTML code to your widget areas.' );
 		$content .= '</p>';
 
-		$content .= '<p>' . __( 'When using a keyboard to navigate:' ) . '</p>';
-		$content .= '<ul>';
-		$content .= '<li>' . __( 'In the HTML edit field, Tab enters a tab character.' ) . '</li>';
-		$content .= '<li>' . __( 'To move keyboard focus, press Esc then Tab for the next element, or Esc then Shift+Tab for the previous element.' ) . '</li>';
-		$content .= '</ul>';
+		$content .= '<p id="editor-keyboard-trap-help">';
+		$content .= __( 'When using a keyboard: In the editing area the Tab key enters a tab character. To move away from this area by pressing Tab, press the Esc key followed by the Tab key. Screen reader users: you may need to press the Esc key twice to exit forms mode and then to allow the Tab key to move away from the editing area.' );
+		$content .= '</p>';
 
 		$content .= '<p>';
 		$content .= sprintf(
 			/* translators: placeholder is link to user profile */
-			__( 'The edit field automatically highlights code syntax. You can disable this in your %s to work in plan text mode.' ),
+			__( 'The edit field automatically highlights code syntax. You can disable this in your %s to work in plain text mode.' ),
 			sprintf(
 				' <a href="%1$s" class="external-link" target="_blank">%2$s<span class="screen-reader-text">%3$s</span></a>',
 				esc_url( get_edit_profile_url() . '#syntax_highlighting' ),