Index: src/wp-admin/includes/plugin.php
===================================================================
--- src/wp-admin/includes/plugin.php	(revision 42702)
+++ src/wp-admin/includes/plugin.php	(working copy)
@@ -463,7 +463,11 @@
  *
  * Plugins in the mu-plugins/ folder can't be "activated," so this function will
  * return false for those plugins.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 2.5.0
  *
  * @param string $plugin Path to the main plugin file from plugins directory.
@@ -477,7 +481,11 @@
  * Check whether the plugin is inactive.
  *
  * Reverse of is_plugin_active(). Used as a callback.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 3.1.0
  * @see is_plugin_active()
  *
@@ -495,7 +503,11 @@
  *
  * Plugins in the mu-plugins/ folder can't be "activated," so this function will
  * return false for those plugins.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 3.0.0
  *
  * @param string $plugin Path to the main plugin file from plugins directory.
Index: src/wp-includes/admin-bar.php
===================================================================
--- src/wp-includes/admin-bar.php	(revision 42702)
+++ src/wp-includes/admin-bar.php	(working copy)
@@ -1118,7 +1118,11 @@
 
 /**
  * Determine whether the admin bar should be showing.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 3.1.0
  *
  * @global bool   $show_admin_bar
Index: src/wp-includes/author-template.php
===================================================================
--- src/wp-includes/author-template.php	(revision 42702)
+++ src/wp-includes/author-template.php	(working copy)
@@ -524,7 +524,11 @@
  * Does this site have more than one author
  *
  * Checks to see if more than one author has published posts.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 3.2.0
  *
  * @global wpdb $wpdb WordPress database abstraction object.
Index: src/wp-includes/category-template.php
===================================================================
--- src/wp-includes/category-template.php	(revision 42702)
+++ src/wp-includes/category-template.php	(working copy)
@@ -231,6 +231,10 @@
  * Prior to v2.7, only one category could be compared: in_category( $single_category ).
  * Prior to v2.7, this function could only be used in the WordPress Loop.
  * As of 2.7, the function can be used anywhere if it is provided a post ID or post object.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 1.2.0
  *
@@ -1415,6 +1419,10 @@
  * Prior to v2.7 of WordPress, tags given as integers would also be checked against the post's tags' names and slugs (in addition to term_ids)
  * Prior to v2.7, this function could only be used in the WordPress Loop.
  * As of 2.7, the function can be used anywhere if it is provided a post ID or post object.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.6.0
  *
Index: src/wp-includes/comment-template.php
===================================================================
--- src/wp-includes/comment-template.php	(revision 42702)
+++ src/wp-includes/comment-template.php	(working copy)
@@ -1202,7 +1202,11 @@
 
 /**
  * Whether the current post is open for comments.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @param int|WP_Post $post_id Post ID or WP_Post object. Default current post.
@@ -1228,6 +1232,10 @@
 
 /**
  * Whether the current post is open for pings.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 1.5.0
  *
Index: src/wp-includes/deprecated.php
===================================================================
--- src/wp-includes/deprecated.php	(revision 42702)
+++ src/wp-includes/deprecated.php	(working copy)
@@ -2511,7 +2511,11 @@
  * Is the current admin page generated by a plugin?
  *
  * Use global $plugin_page and/or get_plugin_page_hookname() hooks.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  * @deprecated 3.1.0
  *
@@ -3714,7 +3718,11 @@
 
 /**
  * Whether the current URL is within the comments popup window.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  * @deprecated 4.5.0
  *
Index: src/wp-includes/functions.php
===================================================================
--- src/wp-includes/functions.php	(revision 42702)
+++ src/wp-includes/functions.php	(working copy)
@@ -673,7 +673,11 @@
 /**
  * Whether the publish date of the current post in the loop is different from the
  * publish date of the previous post in the loop.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 0.71
  *
  * @global string $currentday  The day of the current post in the loop.
@@ -1389,6 +1393,10 @@
  * cache, and the database goes away, then you might have problems.
  *
  * Checks for the 'siteurl' option for whether WordPress is installed.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.1.0
  *
Index: src/wp-includes/functions.wp-scripts.php
===================================================================
--- src/wp-includes/functions.wp-scripts.php	(revision 42702)
+++ src/wp-includes/functions.wp-scripts.php	(working copy)
@@ -320,7 +320,11 @@
 
 /**
  * Check whether a script has been added to the queue.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ *  
  * @since 2.8.0
  * @since 3.5.0 'enqueued' added as an alias of the 'queue' list.
  *
Index: src/wp-includes/l10n.php
===================================================================
--- src/wp-includes/l10n.php	(revision 42702)
+++ src/wp-includes/l10n.php	(working copy)
@@ -1288,6 +1288,10 @@
 
 /**
  * Checks if current locale is RTL.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 3.0.0
  *
Index: src/wp-includes/load.php
===================================================================
--- src/wp-includes/load.php	(revision 42702)
+++ src/wp-includes/load.php	(working copy)
@@ -762,6 +762,10 @@
  * Does not check if the user is an administrator; current_user_can()
  * for checking roles and capabilities.
  *
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook. 
+ *
  * @since 1.5.1
  *
  * @global WP_Screen $current_screen
Index: src/wp-includes/pluggable.php
===================================================================
--- src/wp-includes/pluggable.php	(revision 42702)
+++ src/wp-includes/pluggable.php	(working copy)
@@ -983,6 +983,10 @@
 	/**
 	 * Checks if the current visitor is a logged in user.
 	 *
+	 * For more information on this and similar theme functions, check out
+	 * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+	 * Conditional Tags} article in the Theme Developer Handbook.
+	 * 
 	 * @since 2.0.0
 	 *
 	 * @return bool True if user is logged in, false if not logged in.
Index: src/wp-includes/post-template.php
===================================================================
--- src/wp-includes/post-template.php	(revision 42702)
+++ src/wp-includes/post-template.php	(working copy)
@@ -413,6 +413,10 @@
 
 /**
  * Whether the post has a custom excerpt.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.3.0
  *
@@ -1691,7 +1695,11 @@
  * This template tag allows you to determine if you are in a page template.
  * You can optionally provide a template name or array of template names
  * and then the check will be specific to that template.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 2.5.0
  * @since 4.2.0 The `$template` parameter was changed to also accept an array of page templates.
  * @since 4.7.0 Now works with any post type, not just pages.
Index: src/wp-includes/post-thumbnail-template.php
===================================================================
--- src/wp-includes/post-thumbnail-template.php	(revision 42702)
+++ src/wp-includes/post-thumbnail-template.php	(working copy)
@@ -11,6 +11,10 @@
 
 /**
  * Check if post has an image attached.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.9.0
  * @since 4.4.0 `$post` can be a post ID or WP_Post object.
Index: src/wp-includes/post.php
===================================================================
--- src/wp-includes/post.php	(revision 42702)
+++ src/wp-includes/post.php	(working copy)
@@ -972,6 +972,10 @@
 
 /**
  * Check if a post type is registered.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 3.0.0
  *
@@ -1985,7 +1989,11 @@
  *
  * Sticky posts should remain at the top of The Loop. If the post ID is not
  * given, then The Loop ID for the current post will be used.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 2.7.0
  *
  * @param int $post_id Optional. Post ID. Default is ID of the global $post.
@@ -5046,7 +5054,11 @@
 
 /**
  * Check if the attachment URI is local one and is really an attachment.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 2.0.0
  *
  * @param string $url URL to check
@@ -5521,6 +5533,10 @@
 
 /**
  * Checks if the attachment is an image.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.1.0
  * @since 4.2.0 Modified into wrapper for wp_attachment_is() and
Index: src/wp-includes/query.php
===================================================================
--- src/wp-includes/query.php	(revision 42702)
+++ src/wp-includes/query.php	(working copy)
@@ -139,7 +139,11 @@
  * Is the query for an existing archive page?
  *
  * Month, Year, Category, Author, Post Type archive...
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -159,7 +163,11 @@
 
 /**
  * Is the query for an existing post type archive page?
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 3.1.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -180,7 +188,11 @@
 
 /**
  * Is the query for an existing attachment page?
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 2.0.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -204,7 +216,11 @@
  *
  * If the $author parameter is specified, this function will additionally
  * check if the query is for one of the authors specified.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -228,7 +244,11 @@
  *
  * If the $category parameter is specified, this function will additionally
  * check if the query is for one of the categories specified.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -252,6 +272,10 @@
  *
  * If the $tag parameter is specified, this function will additionally
  * check if the query is for one of the tags specified.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.3.0
  *
@@ -280,6 +304,10 @@
  * If the $term parameter is specified in addition to the $taxonomy parameter,
  * this function will additionally check if the query is for one of the terms
  * specified.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.5.0
  *
@@ -302,7 +330,11 @@
 
 /**
  * Is the query for an existing date archive?
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -324,7 +356,11 @@
  * Is the query for an existing day archive?
  *
  * A conditional check to test whether the page is a date-based archive page displaying posts for the current day.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -344,7 +380,11 @@
 
 /**
  * Is the query for a feed?
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -394,7 +434,11 @@
  * true when viewing that page.
  *
  * Otherwise the same as @see is_home()
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 2.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -422,7 +466,11 @@
  *
  * If a static page is set for the front page of the site, this function will return true only
  * on the page you set as the "Posts page".
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @see is_front_page()
@@ -443,7 +491,11 @@
 
 /**
  * Is the query for an existing month archive?
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -466,7 +518,11 @@
  *
  * If the $page parameter is specified, this function will additionally
  * check if the query is for one of the pages specified.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @see is_single()
  * @see is_singular()
  *
@@ -490,7 +546,11 @@
 
 /**
  * Is the query for paged result and not for the first page?
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -510,7 +570,11 @@
 
 /**
  * Is the query for a post or page preview?
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 2.0.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -550,7 +614,11 @@
 
 /**
  * Is the query for a search?
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -575,7 +643,11 @@
  *
  * If the $post parameter is specified, this function will additionally
  * check if the query is for one of the Posts specified.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @see is_page()
  * @see is_singular()
  *
@@ -603,7 +675,11 @@
  *
  * If the $post_types parameter is specified, this function will additionally
  * check if the query is for one of the Posts Types specified.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @see is_page()
  * @see is_single()
  *
@@ -627,6 +703,10 @@
 
 /**
  * Is the query for a specific time?
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 1.5.0
  *
@@ -647,6 +727,10 @@
 
 /**
  * Is the query for a trackback endpoint call?
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 1.5.0
  *
@@ -667,6 +751,10 @@
 
 /**
  * Is the query for an existing year archive?
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 1.5.0
  *
@@ -687,7 +775,11 @@
 
 /**
  * Is the query a 404 (returns no results)?
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 1.5.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -727,7 +819,11 @@
 
 /**
  * Is the query the main query?
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 3.3.0
  *
  * @global WP_Query $wp_query Global WP_Query instance.
@@ -771,6 +867,10 @@
 
 /**
  * Whether the caller is in the Loop.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.0.0
  *
Index: src/wp-includes/taxonomy.php
===================================================================
--- src/wp-includes/taxonomy.php	(revision 42702)
+++ src/wp-includes/taxonomy.php	(working copy)
@@ -262,6 +262,10 @@
  * Checks that the taxonomy name exists.
  *
  * Formerly is_taxonomy(), introduced in 2.3.0.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 3.0.0
  *
@@ -283,6 +287,10 @@
  * object, and finally returns the hierarchical value in the object.
  *
  * A false return value might also mean that the taxonomy does not exist.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.3.0
  *
@@ -1318,6 +1326,10 @@
  * Check if Term exists.
  *
  * Formerly is_term(), introduced in 2.3.0.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 3.0.0
  *
Index: src/wp-includes/user.php
===================================================================
--- src/wp-includes/user.php	(revision 42702)
+++ src/wp-includes/user.php	(working copy)
@@ -1370,6 +1370,10 @@
 
 /**
  * Checks whether the given username exists.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.0.0
  *
@@ -1396,6 +1400,10 @@
 
 /**
  * Checks whether the given email exists.
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
  *
  * @since 2.1.0
  *
Index: src/wp-includes/widgets.php
===================================================================
--- src/wp-includes/widgets.php	(revision 42702)
+++ src/wp-includes/widgets.php	(working copy)
@@ -812,7 +812,11 @@
  *
  * NOTE: $widget_id and $id_base are the same for single widgets. To be effective
  * this function has to run after widgets have initialized, at action {@see 'init'} or later.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 2.2.0
  *
  * @global array $wp_registered_widgets
@@ -850,7 +854,11 @@
 
 /**
  * Whether the dynamic sidebar is enabled and used by theme.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 2.2.0
  *
  * @global array $wp_registered_widgets
@@ -875,7 +883,11 @@
 
 /**
  * Whether a sidebar is in use.
- *
+ * 
+ * For more information on this and similar theme functions, check out
+ * the {@link https://developer.wordpress.org/themes/basics/conditional-tags/ 
+ * Conditional Tags} article in the Theme Developer Handbook.
+ * 
  * @since 2.8.0
  *
  * @param string|int $index Sidebar name, id or number to check.