Index: src/wp-admin/css/edit.css
===================================================================
--- src/wp-admin/css/edit.css	(revision 42998)
+++ src/wp-admin/css/edit.css	(working copy)
@@ -648,7 +648,7 @@
 
 /* Sugested text for privacy policy postbox */
 .privacy-text-box {
-	margin: 10px 0 0;
+	margin: -6px -12px -12px;
 }
 
 .privacy-text-box-head {
@@ -662,7 +662,7 @@
 }
 
 .privacy-text-box-head p {
-	padding: 0 12px 14px;
+	padding: 12px 12px 14px;
 	margin: 0;
 }
 
@@ -671,13 +671,9 @@
 	overflow: auto;
 }
 
-#privacy-text-box .inside {
-	margin: 0;
-}
-
 .privacy-text-box h3 {
 	font-size: 1em;
-	margin: 1em 0 0.5em;
+	margin: 1em 0 0.1em;
 }
 
 .privacy-text-section .privacy-text-copy {
@@ -686,7 +682,7 @@
 
 .privacy-text-section {
 	position: relative;
-	padding: 1px 14px 1px 12px;
+	padding: 1px 12px;
 	border-top: 1px solid #e3e3e3;
 	border-left: 4px solid transparent;
 }
@@ -707,21 +703,18 @@
 	font-weight: 600;
 }
 
-.closed .privacy-text-box-body {
-	display: none;
-}
-
-.privacy-text-section.folded {
-	height: 150px;
+.privacy-text-section.fold {
+	height: 140px;
 	overflow: hidden;
 }
 
 .privacy-text-actions {
 	line-height: 32px;
-	padding-bottom: 6px;
+	padding-bottom: 8px;
+	margin-top: -8px;
 }
 
-.folded .privacy-text-actions {
+.fold .privacy-text-actions {
 	position: absolute;
 	bottom: 0;
 	background-color: white;
@@ -740,12 +733,12 @@
 }
 
 .policy-text-more,
-.folded .privacy-text-copy,
-.folded .policy-text-less {
+.fold .privacy-text-copy,
+.fold .policy-text-less {
 	display: none;
 }
 
-.folded .policy-text-more {
+.fold .policy-text-more {
 	display: inline;
 }
 
Index: src/wp-admin/edit-form-advanced.php
===================================================================
--- src/wp-admin/edit-form-advanced.php	(revision 42998)
+++ src/wp-admin/edit-form-advanced.php	(working copy)
@@ -37,6 +37,7 @@
 
 wp_enqueue_script( 'post' );
 $_wp_editor_expand = $_content_editor_dfw = false;
+$_wp_privacy_policy_page = ( 'page' === $post_type && $post_ID === (int) get_option( 'wp_page_for_privacy_policy' ) );
 
 /**
  * Filters whether to enable the 'expand' functionality in the post editor.
@@ -56,6 +57,11 @@
 	$_wp_editor_expand   = ( get_user_setting( 'editor_expand', 'on' ) === 'on' );
 }
 
+// No editor expand for the Privacy Policy page. Makes it harder to see/access the postbox under the editor.
+if ( $_wp_privacy_policy_page ) {
+	$_wp_editor_expand = false;
+}
+
 if ( wp_is_mobile() ) {
 	wp_enqueue_script( 'jquery-touch-punch' );
 }
@@ -243,6 +249,10 @@
 // All meta boxes should be defined and added before the first do_meta_boxes() call (or potentially during the do_meta_boxes action).
 require_once( ABSPATH . 'wp-admin/includes/meta-boxes.php' );
 
+// Privacy policy metabox.
+if ( $_wp_privacy_policy_page ) {
+	add_meta_box( 'privacypolicy', __( 'Suggested Privacy Policy Content' ), array( 'WP_Privacy_Policy_Content', 'privacy_policy_postbox' ), 'page', 'normal', 'high' );
+}
 
 $publish_callback_args = null;
 if ( post_type_supports( $post_type, 'revisions' ) && 'auto-draft' != $post->post_status ) {
Index: src/wp-admin/includes/admin-filters.php
===================================================================
--- src/wp-admin/includes/admin-filters.php	(revision 42998)
+++ src/wp-admin/includes/admin-filters.php	(working copy)
@@ -136,9 +136,6 @@
 // Privacy policy text changes check.
 add_action( 'admin_init', array( 'WP_Privacy_Policy_Content', 'text_change_check' ), 20 );
 
-// Show a "postbox" with the text suggestions for a privacy policy.
-add_action( 'edit_form_after_title', array( 'WP_Privacy_Policy_Content', 'privacy_policy_postbox' ) );
-
 // Add the suggested policy text from WordPress.
 add_action( 'admin_init', array( 'WP_Privacy_Policy_Content', 'add_suggested_content' ), 15 );
 
Index: src/wp-admin/includes/misc.php
===================================================================
--- src/wp-admin/includes/misc.php	(revision 42998)
+++ src/wp-admin/includes/misc.php	(working copy)
@@ -1571,7 +1571,7 @@
 
 			$plugin_name = esc_html( $section['plugin_name'] );
 
-			$content .= '<div class="privacy-text-section folded' . $class . '">';
+			$content .= '<div class="privacy-text-section fold' . $class . '">';
 			$content .= '<h3>' . $plugin_name . '</h3>';
 
 			if ( ! empty( $meta ) ) {
@@ -1603,15 +1603,11 @@
 		}
 
 		?>
-		<div id="privacy-text-box" class="privacy-text-box postbox <?php echo postbox_classes( 'privacy-text-box', 'page' ); ?>">
-			<button type="button" class="handlediv" aria-expanded="true">
-				<span class="screen-reader-text"><?php _e( 'Toggle panel: Suggested privacy policy text' ); ?></span>
-				<span class="toggle-indicator" aria-hidden="true"></span>
-			</button>
-			<div class="privacy-text-box-head hndle">
-				<h2><?php _e( 'This suggested privacy policy text comes from plugins and themes you have installed.' ); ?></h2>
+		<div class="privacy-text-box">
+			<div class="privacy-text-box-head">
 				<p>
-					<?php _e( 'We suggest reviewing this text then copying and pasting it into your privacy policy page.' ); ?>
+					<?php _e( 'This suggested content comes from plugins and themes you have installed.' ); ?>
+					<?php _e( 'We suggest reviewing it then copying and pasting it into your privacy policy page.' ); ?>
 					<?php _e( 'Please remember you are responsible for the policies you choose to adopt, so review the content and make any necessary edits.' ); ?>
 				</p>
 			</div>
Index: src/wp-admin/includes/screen.php
===================================================================
--- src/wp-admin/includes/screen.php	(revision 42998)
+++ src/wp-admin/includes/screen.php	(working copy)
@@ -118,8 +118,14 @@
 				if ( false == $box || ! $box['title'] ) {
 					continue;
 				}
-				// Submit box cannot be hidden
-				if ( 'submitdiv' == $box['id'] || 'linksubmitdiv' == $box['id'] ) {
+
+				// These cannot be hidden
+				$not_hidden = array(
+					'submitdiv',
+					'linksubmitdiv',
+					'privacypolicy',
+				);
+				if ( in_array( $box['id'], $not_hidden, true ) ) {
 					continue;
 				}
 
Index: src/wp-admin/js/post.js
===================================================================
--- src/wp-admin/js/post.js	(revision 42998)
+++ src/wp-admin/js/post.js	(working copy)
@@ -1269,34 +1269,3 @@
 	} );
 
 } )( jQuery, new wp.utils.WordCounter() );
-
-( function( $ ) {
-	// Privacy policy postbox, copy button.
-	$( document ).on( 'click', function( event ) {
-		var $target = $( event.target );
-		var node, range;
-
-		if ( $target.is( 'button.privacy-text-copy' ) ) {
-			node = $target.parent().parent().find( 'div.policy-text' )[0];
-
-			if ( node ) {
-				try {
-					window.getSelection().removeAllRanges();
-					range = document.createRange();
-					range.selectNodeContents( node );
-					window.getSelection().addRange( range );
-
-					document.execCommand( 'copy' );
-					window.getSelection().removeAllRanges();
-				} catch ( er ) {}
-			}
-		} else if ( $target.is( 'button.policy-text-more' ) ) {
-			$target.parents( '.privacy-text-section' ).removeClass( 'folded' )
-				.find( '.policy-text' ).attr( 'aria-expanded', 'true' );
-		} else if ( $target.is( 'button.policy-text-less' ) ) {
-			$target.parents( '.privacy-text-section' ).addClass( 'folded' )
-				.find( '.policy-text' ).attr( 'aria-expanded', 'false' );
-		}
-	});
-
-} )( jQuery );
Index: src/wp-admin/js/postbox.js
===================================================================
--- src/wp-admin/js/postbox.js	(revision 42998)
+++ src/wp-admin/js/postbox.js	(working copy)
@@ -444,3 +444,34 @@
 	};
 
 }(jQuery));
+
+( function( $ ) {
+	// Privacy policy postbox, copy button.
+	$( document ).on( 'click', function( event ) {
+		var $target = $( event.target );
+		var node, range;
+
+		if ( $target.is( 'button.privacy-text-copy' ) ) {
+			node = $target.parent().parent().find( 'div.policy-text' )[0];
+
+			if ( node ) {
+				try {
+					window.getSelection().removeAllRanges();
+					range = document.createRange();
+					range.selectNodeContents( node );
+					window.getSelection().addRange( range );
+
+					document.execCommand( 'copy' );
+					window.getSelection().removeAllRanges();
+				} catch ( er ) {}
+			}
+		} else if ( $target.is( 'button.policy-text-more' ) ) {
+			$target.parents( '.privacy-text-section' ).removeClass( 'fold' )
+				.find( '.policy-text' ).attr( 'aria-expanded', 'true' );
+		} else if ( $target.is( 'button.policy-text-less' ) ) {
+			$target.parents( '.privacy-text-section' ).addClass( 'fold' )
+				.find( '.policy-text' ).attr( 'aria-expanded', 'false' );
+		}
+	});
+
+} )( jQuery );